# -*- coding:utf-8 -*-
import re

ssq_d = {'河北省': ['河北省', '河北'], '山西省': ['山西省', '山西'], '辽宁省': ['辽宁省', '辽宁'],
         '吉林省': ['吉林省', '吉林'], '黑龙江省': ['黑龙江省', '黑龙江'], '江苏省': ['江苏省', '江苏'],
         '浙江省': ['浙江省', '浙江'], '安徽省': ['安徽省', '安徽'], '福建省': ['福建省', '福建'],
         '江西省': ['江西省', '江西'], '山东省': ['山东省', '山东'], '河南省': ['河南省', '河南'],
         '湖北省': ['湖北省', '湖北'], '湖南省': ['湖南省', '湖南'], '广东省': ['广东省', '广东'],
         '海南省': ['海南省', '海南'], '四川省': ['四川省', '四川'], '贵州省': ['贵州省', '贵州'],
         '云南省': ['云南省', '云南'], '陕西省': ['陕西省', '陕西'], '甘肃省': ['甘肃省', '甘肃'],
         '青海省': ['青海省', '青海'], '台湾省': ['台湾省', '台湾'], '内蒙古自治区': ['内蒙古自治区', '内蒙古'],
         '广西壮族自治区': ['广西壮族自治区', '广西自治区', '广西'],
         '西藏自治区': ['西藏藏族自治区', '西藏自治区', '西藏'],
         '宁夏回族自治区': ['宁夏回族自治区', '宁夏自治区', '宁夏'],
         '新疆维吾尔自治区': ['新疆维吾尔族自治区', '新疆维吾尔自治区', '新疆自治区', '新疆'],
         '北京市': ['北京市', '北京'], '天津市': ['天津市', '天津'], '上海市': ['上海市', '上海'],
         '重庆市': ['重庆市', '重庆'], '香港特别行政区': ['香港特别行政区', '香港'],
         '澳门特别行政区': ['澳门特别行政区', '澳门']}

#提取省市区
def get_ssq(key=None,Index=False):
    """
    :param key: 要提取字符串
    :param Index: 返回省市区所在字符串索引位置
    :return:
    """
    if key:
        getssq= {}
        for k,vs in ssq_d.items():
            for v in vs:
                if v in key:
                    index=key.index(v)
                    getssq[v]=index
                    break
        if Index:
            return getssq
        ssq_list = list(zip(getssq.keys(), getssq.values()))
        return ([v[0] for v in sorted(ssq_list)])
    return ssq_d

def is_ssq(string):
    if string in [v for vs in ssq_d.values() for v in vs]:
        return True
    return False